#define _BSD_SOURCE
#include <stdio.h>
#include <errno.h>
#include <signal.h>

#define GRACE_TIME 3
#define WAITSYNC_TIME 3
#define WAITHALT_TIME 2

#define EXECUTE_SYNC		"/bin/sync"
#define EXECUTE_UMOUNT_HOME	"/bin/umount -f /home"
#define EXECUTE_REBOOT		"/bin/reboot"

int main(int argc, char **argv)
	{
	sigblock(~0);
	if (kill(-1, SIGTERM) < 0)	/* give a word to the wise */
		perror("warning: kill returned");
	sleep(GRACE_TIME);
	system(EXECUTE_SYNC);
	system(EXECUTE_SYNC);
	system(EXECUTE_SYNC);
	sleep(WAITSYNC_TIME);
	system(EXECUTE_UMOUNT_HOME);
	while(1){
		system(EXECUTE_REBOOT);
		sleep(WAITHALT_TIME);
	}
	}
